> For the complete documentation index, see [llms.txt](https://docs.wisej.com/ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/ai/components/api/smarttool.md).

# SmartTool

Namespace: **Wisej.AI**

Assembly: **Wisej.AI** (3.5.0.0)

Represents a tool that can be used to perform operations on a target object using a specified method.

{% tabs %}
{% tab title="C#" %}

```csharp
public class SmartTool
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Class SmartTool
```

{% endtab %}
{% endtabs %}

## Constructors

### ![](/files/ptrKjmmRoQB76pvrIqh0) SmartTool(target, method)

Initializes a new instance of the [SmartTool](/ai/components/api/smarttool.md) class with the specified target and method.

| Name       | Type                                                                             | Description                                            |
| ---------- | -------------------------------------------------------------------------------- | ------------------------------------------------------ |
| **target** | [Object](https://docs.microsoft.com/dotnet/api/system.object)                    | The target object on which the method will be invoked. |
| **method** | [MethodInfo](https://docs.microsoft.com/dotnet/api/system.reflection.methodinfo) | The method to be invoked on the target object.         |

**Throws:**

* [ArgumentNullException](https://docs.microsoft.com/dotnet/api/system.argumentnullexception)\
  Thrown when the method is null.

## Properties

### ![](/files/ptrKjmmRoQB76pvrIqh0) Description

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the description of the method.

### ![](/files/ptrKjmmRoQB76pvrIqh0) FullName

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the full name of the method including the namespace.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Name

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the name of the method.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Namespace

[String](https://docs.microsoft.com/dotnet/api/system.string):

### ![](/files/ptrKjmmRoQB76pvrIqh0) NamespaceDescription

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the description of the namespace.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Parameters

[Parameter\[\]](https://docs.wisej.com/api?q=wisej.ai.smarttool+parameter\[]): Gets the parameters of the method.

### ![](/files/ptrKjmmRoQB76pvrIqh0) ReturnType

[Type](https://docs.microsoft.com/dotnet/api/system.type): Gets the return type of the method.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Target

[Object](https://docs.microsoft.com/dotnet/api/system.object): Gets the object containing this tool.

## Methods

### ![](/files/ptrKjmmRoQB76pvrIqh0) GetParametersSchema()

Returns a JSON schema representing the tool's parameters or null when the function doesn't have arguments.

**Returns:** [Object](https://docs.microsoft.com/dotnet/api/system.object). JSON schema object


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.wisej.com/ai/components/api/smarttool.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
